/***************************************************************

   (c) 1996 by Salvador Eduardo Tropea (SET).
   e-mail: salvador@inti.edu.ar, ice@inti.edu.ar

   You can use this code for any purpose if you don't remove the
original copyright.

 Filename -       InfBase.cpp

 Functions
 Member functions of following classes
                      TInfTopic
                      TInfIndex
                      TInfFile

***************************************************************/

#if defined(__GNUC__) && !defined(__DJGPP__)
#define _chmod chmod
#define Linux
#define NO_DOUBLE_CLICK
//#define DEBSTD
#endif

#ifdef FOR_EDITOR
// That's the first include because is used to configure the editor.
#include "ceditint.h"
#endif

#define CUT_NOTES

#ifdef __GNUC__
#include <unistd.h>
#endif

#define Uses_TStreamableClass
#define Uses_TPoint
#define Uses_TStreamable
#define Uses_TRect
#define Uses_MsgBox
#include <tv.h>

#if !defined( __STDLIB_H )
#include <stdlib.h>
#endif // __STDLIB_H

#if !defined( __Inf_H )
#include "infbase.h"
#endif  // __Inf_H

#if !defined( __UTIL_H )
#include "util.h"
#endif  // __UTIL_H

#if !defined( __STRING_H )
#include <string.h>
#endif  // __STRING_H

#if !defined( __LIMITS_H )
#include <limits.h>
#endif  // __LIMITS_H

#if !defined( __STAT_H )
#include <sys/stat.h>
#endif  // __STAT_H

#if !defined( __CTYPE_H )
#include <ctype.h>
#endif  // __CTYPE_H

#ifndef Linux
# if !defined( __IO_H )
#  include <io.h>
# endif  // __IO_H
#endif

#pragma warn -dsz

#define DEBUG
#ifdef DEBUG
# ifndef FOR_EDITOR
# include "nointl.h"
# endif
# ifndef Linux
#  include <conio.h>
#  define Clava(a) { printf(a); getch(); exit(1); }
# else
#  define Clava(a) { fprintf(stderr,a); exit(1); }
# endif
#else
#define Clava(a) exit(1)
#endif

#ifdef __DJGPP__
#include <crt0.h>
#endif

#ifdef Linux
extern "C" char *strupr(char *);
extern "C" int stricmp(const char *,const char *);
extern "C" int strnicmp(const char *,const char *,size_t n);
#endif

const TabSize=8;

/*
void *operator new(size_t size)
{
 void * p;

 size = size ? size : 1;
 p = malloc(size);
 if (p==NULL)
   {
    printf(_("Error memory exhausted!!!\n"));
    getch();
    exit(1);
   }
 memset(p,1,size);

 return p;
}

void operator delete(void *p)
{
 if (p==NULL)
   {
    printf(_("Error: pointer is NULL!!!\n"));
    getch();
    long pp=((long *)p)[0];
    printf("%lX\n",pp);
   }
 else
 free(p);
}
*/
// TInfTopic

void *TInfTopic::Read( TInfFile &File )
{
 FILE *f=File.stream;

 ReadNodeInfo(File);
 if (!Status)
   {
    ReadText(f);
    ReadCrossRefs();
   }
 width = 0;
 lastLine = INT_MAX;
 return this;
}


static void CopiarDatosDe(char *Tipo,char *Dest,char *Ori)
{
 char *pos,*s;
 int largo;

 if ((pos=strstr(Ori,Tipo))!=NULL)
   {
    pos+=strlen(Tipo)+2;
    for (s=pos,largo=0; *s && *s!='\n' && *s!='\r' && *s!=',' && *s!='\t'; s++,largo++);
    *s=0;
    if (largo>MAX_NODE_NAME)
       Dest[0]=0;
    else
       strcpy(Dest,pos);
    *s=',';
   }
 else
   Dest[0]=0;
}

void TInfTopic::ReadNodeInfo(TInfFile &File)
{
 char Buf[256];
 FILE *f=File.stream;
 long Pos=ftell(f);

 do
   { fgets(Buf,256,f); }
 while(Buf[0]==31 || isspace(Buf[0]));
 if (strncmp(Buf,"File",4)==0)
   {
    CopiarDatosDe("Node",Node,Buf);
    CopiarDatosDe("Next",Next,Buf);
    CopiarDatosDe("Prev",Prev,Buf);
    CopiarDatosDe("Up",Up,Buf);
   }
 else
   {
    if (Buf[strlen(Buf)-2]=='\r')
      {
       if (File.IsCompressed)
         {
          //messageBox(_("Attention !! this file is in DOS format,"
          //             "and is compressed, uncompress the file,"
          //             " reopen it with the Help and then recompress it."),
          //             mfError | mfOKButton);
          if (!File.ConvertIt(Pos))
            {
             Status=True;
             return;
            }
          ReadNodeInfo(File);
          return;
         }
       else
         {
          if (messageBox(_("Attention !! this file is in DOS format,"
              " Do you want convert it?,"
              " Make a backup first !!"), mfError | mfYesButton | mfNoButton)
              ==cmYes)
            {
             if (!File.ConvertIt(Pos))
               {
                Status=True;
                return;
               }
             ReadNodeInfo(File);
             return;
            }
         }
       Status=True;
       return;
      }
    messageBox(_("Error: can't find the Node info"),mfError | mfOKButton);
    Status=True;
    return;
   }
}

TInfTopic::TInfTopic( )
{
 numRefs = 0;
 crossRefs = 0;
 width = 0;
 lastOffset = 0;
 lastLine = INT_MAX;
 Text = NULL;
 Node[0]=Next[0]=Prev[0]=Up[0]=0;
 Status=False; // OK
};

void TInfTopic::ReadText( FILE *f )
{
 char Buf[256];
 char *s,*d;
 int i,x,t;
 int lWidth;

 // Primera pasada: mide
 long Pos=ftell(f);
 lSize=0;
 iLines=0;
 fgets(Buf,256,f);
 maxLineWidth = 0;
 do
  {
   lWidth = strlen(Buf);
   if (lWidth>maxLineWidth)
      maxLineWidth = lWidth;
   lSize+=lWidth;
   iLines++;
   fgets(Buf,256,f);
   for (s=Buf;*s;s++)
       if (*s=='\t')
          lSize+=TabSize;
  }
 while (Buf[0]!=31 && !feof(f));

 // Arriba
 #ifndef __GNUC__
 if (lSize>60000L) Clava("TInfTopic::ReadText: Super los 60Kb\n");
 fseek(f,Pos,SEEK_SET);
 Text = new char[(size_t)lSize+1];
 #else
 fseek(f,Pos,SEEK_SET);
 Text = new char[lSize+1];
 #endif
 for (i=iLines, d=Text; i; --i)
    {
     fgets(Buf,256,f);
     for (s=Buf,x=0;*s;s++)
         if (*s=='\t')
           {
            t=TabSize-(x%TabSize);
            x+=t; 
            for (int j=t;j;--j) *d++=' ';
           } 
         else
           {
            x++;
            if (*s!='\r')
               *d++=*s;
           }
    }
 *d=0;
}


static int IsDelimiterDeXX( int Val )
{
 return Val==' ' || Val=='\r' || Val=='\t' || Val=='\n' || Val=='.' ||
        Val==0  || Val==',' || Val==';' || Val==')'  || Val=='(';
}

static void TakeName(char *Buf,char *Nom,int &ini,int &largo,int &Linea, int &linebreak)
{
 char *s,*ori;
 int CruzaLin,OffEnProxLin=0,EnParentesis;

 ini+=1;
 largo=0;
 CruzaLin=0;
 // Quitar espacios indeceables
 for (ori=Buf+1; isspace(*ori) && *ori; ori++)
    {
     if (*ori=='\n')
       {
        // Opss se cay
        Linea++;
        ini=0;
       }
     else
        ini++;
    }
 // El primer : puesto ac no cuenta
 if (*ori==':')
   {
    ori++;
    ini++;
   }
 for (s=Nom; *ori; s++,ori++)
    {
     if (*ori==':')
       {
        if (!isalpha(ori[1]) || ( ori[1]==':' && IsDelimiterDeXX(ori[2]) ) )
           break;
        *s++=*ori++;
        largo++;
       }
     if (*ori=='\n')
       {
        *s++=' ';
        ori++;
        for (OffEnProxLin=0;*ori && isspace(*ori); ori++,OffEnProxLin++,largo++);
        CruzaLin=1;
        largo++;
       }
     else
       {
        if (CruzaLin)
           OffEnProxLin++;
        largo++;
       }
     *s=*ori;
    }
 *s=0;
 ori++;
 linebreak=OffEnProxLin;
 if (*ori==':') return;
 if (CruzaLin)
   {
    CruzaLin=0;
    Linea++;
    ini=++OffEnProxLin;
    OffEnProxLin=0;
   }
 else
    ini+=largo;
 largo=0;
 for (ini++;*ori && isspace(*ori); ori++,ini++)
    {
     if (*ori=='\n')
       {
        Linea++;
        ini=-1;
       }
    }
 EnParentesis=0;
 for (s=Nom; *ori && *ori!=':' && (*ori!='.' || EnParentesis || !IsDelimiterDeXX(*(ori+1))) && *ori!=','; s++,ori++)
    {
     if (*ori=='\n')
       {
        *s++=' ';
        ori++;
        for (OffEnProxLin=0;*ori && isspace(*ori); ori++,OffEnProxLin++,largo++);
        CruzaLin=1;
        largo++;
       }
     else
       {
        if (CruzaLin)
           OffEnProxLin++;
        largo++;
        if (*ori=='(')
           EnParentesis=1;
        else
          if (EnParentesis && *ori==')')
             EnParentesis=0;
       }
     *s=*ori;
    }
 *s=0;
 linebreak=OffEnProxLin;
}

/* First approach, hmmmm ... I think that this won't work with
   2 notes in the same line, one crossing the end
void CutNoteStr(char *s)
{
 char *end;
 for (end=s; *end!='\n'; end++);
 int cant;
 if (s[5]==' ')
    cant=6;
 else
    cant=5;
 memcpy(s,s+cant,end-s-cant);
 s=end-cant;
 int i;
 for (i=cant; i; i--,s++)
     *s=' ';
}
*/

void CutNoteStr(char *s, char *ori, long &size)
{
 int cant;
 if (s[5]==' ')
    cant=6;
 else
    cant=5;
 memcpy(s,s+cant,size_t(size-(s-ori)-cant));
 size-=cant;
}

void TInfTopic::ReadCrossRefs( void )
{
 CrossRef *crossRefPtr;
 char Buf[256],BufLine[256];
 int Linea,LineaMenu=0,iMenues;
 int OffInLine,Length,OffInThisLine,LineOfNote;
 // Para los notes
 char *cpPos,*cpFin,*cpMenu;
 int iNotes,iNAdd=0,iRAdd,iMAdd;

 // Barrer el texto buscando todos los *?ote y * Menu
 iNotes=0;
 cpMenu=cpFin=Text+(int)lSize-6;
 cpPos=Text;
 Linea=1;
 while (cpPos<cpFin)
    {
     if (*cpPos=='*' && cpPos[2]=='o' && cpPos[3]=='t'
         && cpPos[4]=='e' && isspace(cpPos[5]) )
       {
        iNotes++;
        cpPos+=4;
       }
     else
       if (!LineaMenu && *cpPos=='*' && cpPos[1]==' ' && cpPos[2]=='M'
           && cpPos[3]=='e' && cpPos[4]=='n' && cpPos[5]=='u')
         {
          cpMenu=cpPos;
          cpPos+=4;
          LineaMenu=Linea;
         }
       else
         if (*cpPos=='\n')
            Linea++;
     cpPos++;
    }

 // Medir el men
 Linea=LineaMenu+1;
 iMenues=0;
 do
  {
   getLine(Linea++,BufLine);
   if (*BufLine=='*' && BufLine[1]==' ')
      iMenues++;
  }
 while(Linea<iLines /*&& (*BufLine=='*' || isspace(*BufLine) || *BufLine==0)*/);

 numRefs=iMenues+iNotes;

 if (numRefs)
   {
    crossRefs = new CrossRef[numRefs];
    // Agregar todas las Note antes del men
    cpPos=Text;
    Linea=1;
    iRAdd=0;
    OffInThisLine=0;
    if (iNotes)
      {
       for (iNAdd=0; iNAdd<iNotes && cpPos<cpMenu; )
          {
           if (*cpPos=='*' && cpPos[2]=='o' && cpPos[3]=='t'
               && cpPos[4]=='e' && isspace(cpPos[5]))
             {
#ifdef CUT_NOTES
              //CutNoteStr(cpPos);
              CutNoteStr(cpPos,Text,lSize);
              cpPos--;
              OffInThisLine--;
#else
              cpPos+=4;
              OffInThisLine+=4;
#endif
              crossRefPtr = (CrossRef *)crossRefs + iRAdd;
              LineOfNote=Linea;
              OffInLine=OffInThisLine-1;
              TakeName(cpPos,Buf,OffInLine,Length,LineOfNote,crossRefPtr->linebreak);
              strcpy(crossRefPtr->Name,Buf);
              crossRefPtr->offset=OffInLine;
              crossRefPtr->line=LineOfNote;
              crossRefPtr->length=Length;
              iNAdd++;
              iRAdd++;
             }
           else
             if (*cpPos=='\n')
               {
                Linea++;
                OffInThisLine=0;
               }
           cpPos++;
           OffInThisLine++;
          }
      }
    if (iMenues)
      {
       Linea=LineaMenu+1;
       iMAdd=0;
       do
        {
         getLine(Linea,BufLine);
         if (*BufLine=='*' && BufLine[1]==' ')
           {
            crossRefPtr = (CrossRef *)crossRefs + iRAdd;
            LineOfNote=Linea;
            OffInLine=0;
            TakeName(BufLine,Buf,OffInLine,Length,LineOfNote,crossRefPtr->linebreak);
            strcpy(crossRefPtr->Name,Buf);
            crossRefPtr->offset=OffInLine;
            crossRefPtr->line=LineOfNote;
            crossRefPtr->length=Length;
            iMAdd++;
            iRAdd++;
           }
         Linea++;
        }
       while(iMAdd<iMenues);
      }
    // Agregar las que estn atrs del men
    if (iNotes && iNAdd<iNotes)
      {
       cpPos=cpMenu;
       Linea=LineaMenu;
       OffInThisLine=0;
       for (; iNAdd<iNotes && cpPos<cpFin; )
          {
           if (*cpPos=='*' && cpPos[2]=='o' && cpPos[3]=='t'
               && cpPos[4]=='e' && isspace(cpPos[5]))
             {
#ifdef CUT_NOTES
              //CutNoteStr(cpPos);
              CutNoteStr(cpPos,Text,lSize);
              cpPos--;
              OffInThisLine--;
#else
              cpPos+=4;
              OffInThisLine+=4;
#endif
              crossRefPtr = (CrossRef *)crossRefs + iRAdd;
              LineOfNote=Linea;
              OffInLine=OffInThisLine-1;
              TakeName(cpPos,Buf,OffInLine,Length,LineOfNote,crossRefPtr->linebreak);
              strcpy(crossRefPtr->Name,Buf);
              crossRefPtr->offset=OffInLine;
              crossRefPtr->line=LineOfNote;
              crossRefPtr->length=Length;
              iNAdd++;
              iRAdd++;
             }
           else
             if (*cpPos=='\n')
               {
                Linea++;
                OffInThisLine=0;
               }
           cpPos++;
           OffInThisLine++;
          }
      }
   }
}

TInfTopic::~TInfTopic()
{
 if (crossRefs != 0)
    delete crossRefs;
 if (Text!=NULL)
    delete Text;
}

void TInfTopic::getCrossRef( int i, TPoint& loc, uchar& length, char *& ref,
                             int &pl )
{
 CrossRef *crossRefPtr;

 crossRefPtr = crossRefs + i;
 loc.x = crossRefPtr->offset;
 loc.y = crossRefPtr->line;
 length = crossRefPtr->length;
 ref = crossRefPtr->Name;
 pl = crossRefPtr->linebreak;
}

int TInfTopic::getLine( int line, char *buffer )
{
 int offset, i, l;
 char *s;

 if (lastLine < line)
     {
     i = line;
     line -= lastLine;
     lastLine = i;
     offset = lastOffset;
     }
 else
     {
     offset = 0;
     lastLine = line;
     }
 buffer[0] = 0;
 while (offset < lSize)
 {
  --line;
  if (line == 0)
    {
     char *dest=buffer;
     // Barrer buscando el fin de lnea y copiando
     for (s=Text+offset, l=0; *s && *s!='\n'; s++,offset++,dest++,l++) *dest=*s;
     if (*s=='\n')
       {
        offset++;
        *dest++=0;
       }
     lastOffset = offset;
     return l;
    }
  else
    {
     // Barrer buscando el fin de lnea
     for (s=Text+offset; *s && *s!='\n'; s++,offset++);
     if (*s=='\n') offset++;
    }
 }
 buffer[0] = 0;
 return 0;
}


/*static int MatchFirstLet(char *s,int Val)
{
 for (;*s && !isalpha(*s);s++);
 return (toupper(*s)==Val);
}*/


static int MatchCross(char *s,char *match,int l,int &vislen)
{
 for (vislen=l;*s && !isalpha(*s);s++,vislen++);
 return strnicmp(s,match,l)==0;
}


int TInfTopic::SearchNextWith(char *str,int len,int &selected,int &vislen)
{
 int i,j;

 if (selected<numRefs)
   {
    for (i=selected-1; i<numRefs; i++)
       {
        if (MatchCross(crossRefs[i].Name,str,len,vislen))
          {
           selected=i+1;
           return 1;
          }
       }
   }
 if (numRefs)
   {
    for (j=selected-1,i=0; i<j; i++)
       {
        if (MatchCross(crossRefs[i].Name,str,len,vislen))
          {
           selected=i+1;
           return 1;
          }
       }
   }
 return 0;
}


int TInfTopic::selBestMatch(char *match,int &PerfectMatch)
{
 PerfectMatch=0;
 if (match==0 || numRefs==0) return 0;

 int i,j,BestPoints=0,BestPos=-1;
 char Buf[MAX_NODE_NAME];
 char *s1,*s2;
 strupr(match);
 for (i=numRefs-1; i>=0; --i)
    {
     // Copy & struppr
     for (s1=crossRefs[i].Name, s2=Buf; *s1; s1++,s2++) *s2=toupper(*s1); *s2=0;
     // Compare
     for (s1=Buf, s2=match, j=0; *s1==*s2 && *s1; s1++,s2++,j++);
     if (j>BestPoints)
       {
        BestPoints=j;
        BestPos=i;
       }
    }
 PerfectMatch=(strlen(match)==(size_t)BestPoints);
 return BestPos+1;
}

// TInfIndex
TInfIndex::~TInfIndex()
{
 if (Names!=NULL)
    delete Names;
 if (Offsets!=NULL)
    delete Offsets;
 if (IndOffsets!=NULL)
    delete IndOffsets;
 Names=NULL;
 Offsets=NULL;
 IndOffsets=NULL;
}


TInfIndex::TInfIndex( TInfFile& o, int Indirect )
{
 size = 0;
 indirects=0;
 Names=NULL;
 Offsets=NULL;
 IndOffsets=NULL;

 FILE *f=o.stream;
 Status = False; // OK

#ifdef DEBSTD
 fprintf(stderr,"Loading the Index, indirect: %d\n",Indirect);
#endif
 // Indirecta => varios archivos
 long PosStream = ftell(f);
 if (Indirect)
   {
    // Medir
    do
     {
      o.GetLine();
      if (o.Buffer[0]==31) break;
      indirects++;
     }
    while (!feof(f));
    fseek(f,PosStream,SEEK_SET);
#ifdef DEBSTD
    fprintf(stderr,"Found %d indirects\n",indirects);
#endif
    // Cargar
    IndOffsets=new IndirectIndex[indirects];
    indirects=0;
    do
     {
      char *s,*ori;

      o.GetLine();
      if (o.Buffer[0]==31) break;
      s=IndOffsets[indirects].Name;
      ori=o.Buffer;
      for (;*ori && *ori!=':'; s++,ori++) *s=*ori;
      *s=0;
      ori++;
      IndOffsets[indirects].lPos=atol(ori);
      indirects++;
     }
    while (!feof(f));
#ifdef DEBSTD
    fprintf(stderr,"Loaded %d indirects\n",indirects);
#endif

    // Ir al ndice
    do
     {
      o.GetLine();
      if (strncmp(o.Buffer,"Tag Table",9)==0) break;
      o.SkipNode();
     }
    while(!feof(f));
    if (feof(f))
      {
       #ifdef DEBSTD
       fprintf(stderr,"Tag table not found in indirect table\n");
       #endif
       Status=True;
       return;
      }
    o.GetLine();
   }

 PosStream = ftell(f);
 // Primer pasada para ver la cantidad de elementos
 size=0;
 do
  {
   o.GetLine();
   if (o.Buffer[0]==31) break;
   if (strncmp(o.Buffer,"Node:",5)!=0)
     {
      Status=True;
      return;
     }
   size++;
  }
 while (!feof(f));
 #ifdef DEBSTD
 fprintf(stderr,"Found %d entries in the Tag Table\n",size);
 #endif

 fseek(f,PosStream,SEEK_SET);
 Names = new NameOfNode[size];
 Offsets = new long[size];
 if (Names==NULL || Offsets==NULL)
   {
    #ifdef DEBSTD
    fprintf(stderr,"Failed to allocate memory for the Tag Table");
    #endif
    Status=True;
    return;
   }

 for (int i=0; i<size; i++)
    {
     char *Pos;

     o.GetLine();
     Pos=strchr(o.Buffer+5,127);
     if (Pos==NULL)
       {
        #ifdef DEBSTD
        fprintf(stderr,"Failed to load Tag Table\n");
        #endif
        Status=True;
        return;
       }
     *Pos++=0;
     strcpy(Names[i],o.Buffer+6);
     Offsets[i]=atol(Pos);
    }
 #ifdef DEBSTD
 fprintf(stderr,"Tag Table loaded\n");
 #endif
}


// For files without Tag Table (not real .info, just texts with 0x1F as delimiter)
TInfIndex::TInfIndex( TInfFile& o )
{
 size = 0;
 indirects=0;
 Names=NULL;
 Offsets=NULL;
 IndOffsets=NULL;

 FILE *f=o.stream;
 Status = False; // OK

 // Al ppio.
 rewind(f);

 // Asumo que lo primero es el ttulo y no un nodo.

 // Primer pasada para ver la cantidad de elementos
 size=0;
 do
  {
   o.SkipNode();
   while (!feof(f))
     {
      o.GetLine();
      if (strncmp(o.Buffer,"File:",5)==0)
        {
         size++;
         break;
        }
     }
  }
 while (!feof(f));

 if (!size)
   {
    Status=True;
    return;
   }

 // Al ppio.
 rewind(f);

 // Allocar la RAM
 Names = new NameOfNode[size];
 Offsets = new long[size];
 if (Names==NULL || Offsets==NULL)
   {
    Status=True;
    return;
   }

 // 2da pasada levanta a RAM
 for (int i=0; i<size; i++)
    {
     char *Pos;
     long PosNode;

     o.SkipNode();
     while (!feof(f))
       {
        PosNode=ftell(f);
        o.GetLine();
        if (strncmp(o.Buffer,"File:",5)==0)
          {
           Pos=strstr(o.Buffer+5,"Node:");
           if (Pos==NULL)
             {
              Status=True;
              return;
             }
           Pos+=6;
           char *s;
           int largo;
           for (s=Pos,largo=0; *s && *s!='\n' && *s!='\r' && *s!=',' && *s!='\t'; s++,largo++);
           *s=0;
           if (largo>MAX_NODE_NAME)
              Names[i][0]=0;
           else
              strcpy((char *)(&Names[i]),Pos);
           Offsets[i]=PosNode;
           break;
          }
       }
    }
}

long TInfIndex::position(int i)
{
 if (i<size && !Status)
    return Offsets[i];
 return -1;
}

int TInfIndex::WhatIndex(char *Nom)
{
 int i;

 for (i=0; i<size; i++)
    {
     if (strcmp(Nom,Names[i])==0)
        return i;
    }
 return size+1;
}

int TInfIndex::SearchFirstWith(int Key,int &selected)
{
 int i;

 for (i=0; i<size; i++)
    {
     if (toupper(Names[i][0])==Key)
       {
        selected=i+1;
        return 1;
       }
    }
 return 0;
}



// TInfFile

void TInfFile::DoAll( char *Nombre, int Verbose )
{
 int Indirect=0;
 index=NULL;
 strcpy(NameOfFile,Nombre);
 // Volarle la extensin
 char *s;
 if ((s=strchr(NameOfFile,'.'))!=NULL) *s=0;
 Status=False; // OK

 stream=fOpen(Nombre);
 if (stream==NULL)
   {
    if (Verbose)
#ifndef __GNUC__
       messageBox(_("Attention can't open the help file."), mfError | mfOKButton);
#else
       messageBox(mfError|mfOKButton,_("Attention can't open the help file '%s'."), Nombre);
#endif
    Status=True;
    return;
   }

 // Buscar el Index
 do
  {
   GetLine();
   if (strncmp(Buffer,"Tag Table",9)==0) break;
   if (strncmp(Buffer,"Indirect:",9)==0) { Indirect=1; break; }
   SkipNode();
  }
 while(!feof(stream));

 //   Si fall es que no posee Tag Table, antes yo pensaba que era imposible,
 // pero el Debian crea el dir automaticamente y los idiotas en lugar de
 // crear un verdadero dir.info crean un archivo de texto plano con un solo 0x1F
 // para delimitar el ttulo del nico nodo.
 if (feof(stream))
   {
    // Levantarlo a RAM, pero con un constructor !=
    index=new TInfIndex(*this);
   }
 else
   {
    // Levantarlo a RAM
    index=new TInfIndex(*this,Indirect);
   }
 Status=index->Status;

 if (Indirect && !Status)
   { // Abrir la primera
    fClose(stream);
    iFile=0;
    stream=fOpen(index->IndOffsets[0].Name);
    if (stream==NULL)
      {
       Status=True;
       return;
      }
   }
}

/********************************************************************************

  Function: int TestForFile(char *s)

  Objetive: Test if some file exists and in this case if is a normal file.

  Parameter:
  char *s The name of the file

  Returns:
  -1 Fail
  0 OK

********************************************************************************/

int TestForFile(char *s)
{
 struct stat a;
 if (stat(s,&a)!=0)
    return -1;
 return S_ISREG(a.st_mode) ? 0 : -1;
}

/********************************************************************************

  Function: int TryWithName(char *s, int have_ext, int iExt, int &is_compressed)

  Type: static.

  Objetive: Try to find a file with the specified name but with variants in
  the extention.

  Parameter:
  char *s: a pointer to the name of the file.
  int have_ext: 1 if the original name allready have an extention.
  int iExt: 1 try to add an extention.
  int &is_compressed: returns 1 if the name belongs to a compressed file.

  Returns:
  1 if the file doesn't exists.
  0 if all OK, in this case the string holds the valid name.

********************************************************************************/

static int TryWithName(char *s, int have_ext, int iExt, Boolean &is_compressed)
{
 int a;
 int pos;

 is_compressed=False;
 // Try the normal name
 a=TestForFile(s);
 if (iExt && a==-1)
   {
    // If the normal fails try with .inf
    pos=strlen(s);
    if (!have_ext)
      {
#ifdef Linux
       strcat(s,".info");
#else
       strcat(s,".inf");
#endif
       a=TestForFile(s);
#ifdef DJGPP // try it with .info (LFN !!)
       if (a==-1)
         {
          s[pos]=0;
          strcat(s,".info");
          a=TestForFile(s);
         }
#endif
       if (a==-1)
         {
          // if even this fails, try with .gz
          s[pos]=0;
          is_compressed=True;
#ifdef Linux
          strcat(s,".info.gz");
#else
          strcat(s,".gz");
#endif
          a=TestForFile(s);
          if (a==-1)
            {
             // Well, why not .igz
             s[pos]=0;
#ifdef Linux
	     strcat(s,".gz");
#else
             strcat(s,".igz");
#endif
             a=TestForFile(s);
             if (a==-1)
               {
                // Well, or inz
                s[pos]=0;
                strcat(s,".inz");
                a=TestForFile(s);
               }
            }
         }
      }
    else
      {
#ifndef Linux
       // If allready have an extention
       char *dot=strrchr(s,'.')+1;
       int ext_l=strlen(dot);
       is_compressed=True;
       switch (ext_l)
         {
          case 1: dot[1]='z';
                  dot[2]=0;
                  a=TestForFile(s);
                  if (a==-1)
                    {
                     dot[1]='g';
                     dot[2]='z';
                     dot[3]=0;
                     a=TestForFile(s);
                    }
                  break;
          case 2: dot[2]='z';
                  dot[3]=0;
                  a=TestForFile(s);
                  if (a != -1 && (a & 0x18 /* directory or label */)) a = -1;
                  break;
          case 3: dot[2]='z';
                  a=TestForFile(s);
                  break;
         }
#else
       s[strlen(s)]=0;
       strcat(s,".gz");
       is_compressed=True;
       a=TestForFile(s);
#endif
      }
   }
#ifdef DEBSTD
 fprintf(stderr,"File: %s status: %s\n",s,a==-1 ? "fail" : "found");
#endif
 return a == -1;
}

static int info_env_loaded = 0;

int TInfFile::ExpandName(char *Buf, char *Nombre, int iExt)
{
 int a;
#ifdef __GNUC__
 // Try at first the directories in $INFOPATH, if there are some
 // Get the $INFOPATH like info.exe it sees
# ifdef __DJGPP__
 if (!info_env_loaded)
 {
   __crt0_load_environment_file("info");
   info_env_loaded = 1;
 }
# endif
 char *infodir = getenv("INFOPATH");
 if (infodir)
 {
   char *idir = (char *)alloca(strlen(infodir) + 1);
   char *end=idir,*start=idir;
   strcpy(idir,infodir);
   while (1)
   {
     char c;
     while (*end && *end != ';') end++;
     c = *end;
     *end = 0;
     strcpy(Buf,start);
     strcat(Buf,"/");
     strcat(Buf,Nombre);
     a = TryWithName(Buf,strchr(Nombre,'.')!=NULL,iExt,IsCompressed);
     if (!a)
     {
       Status = False;
       return 0;
     }
     if (!c) break;
     start=end=end+1;
   }
 }
#endif

 char *s=getenv("DJGPP");
 if (s==NULL)
   {
    Status=True;
    return 1;
   }
 strcpy(Buf,s);
 strupr(Buf);
 for (s=Buf; *s; s++) if (*s=='/') *s='\\';
 s=strstr(Buf,"DJGPP.ENV");
 if (s==NULL)
   {
    Status=True;
    return 1;
   }
 s[0]='I';s[1]='N';s[2]='F';s[3]='O';s[4]='\\';
 char *s2=Nombre;
 for (s+=5; *s2; s++,s2++) *s=*s2; *s=0;
 a = TryWithName(Buf,strchr(Nombre,'.')!=NULL,iExt,IsCompressed);
 if (a)
   {
    Status=True;
    return 1;
   }
 return 0;
}

FILE *TInfFile::fOpen(char *Nombre)
{
 char Buf[256];
 char Buf2[512];

 if (ExpandName(Buf,Nombre,1))
    return NULL;
 if (IsCompressed)
   {
#ifndef Linux
    // Just run the gzip and get your output in __infc__
    strcpy(Buf2,"gzip -d -c ");
    strcat(Buf2,Buf);
    strcat(Buf2," > __infc__");
    system(Buf2);
    strcpy(Buf,"__infc__");
#else
    // Not so easy, here we create another process, extract your output and copy
    // it to __infc__, the DOS technique doesn't work well.
    FILE *f,*d;

    strcpy(Buf2,"gzip -d -c ");
    strcat(Buf2,Buf);
    f=popen(Buf2,"r");
    #ifdef DEBSTD
    fprintf(stderr,"Piping: %s returns %s\n",Buf2,f==NULL ? "fail" : "ok");
    #endif
    if (!f) return f;
    if ((d=fopen("__infc__","wb"))==NULL) return d;
    do
     {
      fputc(fgetc(f),d);
     }
    while(!feof(f));
    fclose(d);
    pclose(f);
    strcpy(Buf,"__infc__");
#endif
   }
 return fopen(Buf,"rb");
}

int TInfFile::fClose(FILE *f)
{
 int ret=0;

 if (f!=NULL)
   {
    ret=fclose(f);
    if (IsCompressed)
      {
       unlink("__infc__");
       IsCompressed=False;
      }
   }
 return ret;
}

TInfFile::~TInfFile(void)
{
    if (index!=NULL)
       delete index;
    fClose(stream);
}

void TInfFile::SkipNode(void)
{
 do
  {
   GetLine();
  }
 while(Buffer[0]!=31 && !feof(stream));
}

int TInfFile::fSeek(long Pos)
{
 #ifdef DEBSTD
 fprintf(stderr,"Making a seek to %d\n",Pos);
 #endif
 if (index->indirects)
   {
    int i;
    for (i=0; i<index->indirects && Pos>=index->IndOffsets[i].lPos; i++);
    #ifdef DEBSTD
    fprintf(stderr,"Using the indirect table, entry %d actual %d\n",i-1,iFile);
    #endif
    if (--i!=iFile)
      {
       if (i==-1) return 1;
       iFile=i;
       fClose(stream);
       #ifdef DEBSTD
       fprintf(stderr,"Opening %s\n",index->IndOffsets[i].Name);
       #endif
       stream=fOpen(index->IndOffsets[i].Name);
       #ifdef DEBSTD
       fprintf(stderr,"Result: %s\n",stream==NULL ? "fail" : "ok");
       #endif       
       if (stream==NULL)
          return 1;
      }
    Pos=Pos-index->IndOffsets[i].lPos+index->IndOffsets[0].lPos;
   }
 #ifdef DEBSTD
 fprintf(stderr,"Seeking to %d\n",Pos);
 #endif
 return fseek(stream,Pos,SEEK_SET);
}


TInfTopic *TInfFile::getTopic( char *NameOri, int Verbose )
{
 long pos;
 char cFile[MAX_NODE_NAME];
 char *Name;
 int  WatchDog=MAX_NODE_NAME-1;

 Name=NameOri;
 // Ver de que archivo es
 if (Name[0]=='(')
   {
    char *s=Name+1,*s2=cFile;

    for (;*s!=')' && WatchDog;s++,s2++,WatchDog--) *s2=*s; *s2=0;
    if (!WatchDog)
      {
       messageBox("Guau ... guau!!", mfInformation | mfOKButton);
      }
    Name=s+1;

    if (strcmp(NameOfFile,cFile)!=0)
      { // Se pudri
       if (index!=NULL)
          delete index;
       fClose(stream);
       DoAll(cFile,Verbose);
       if (index==NULL)
          return(invalidTopic());
      }
   }
 if (Status)
    return(invalidTopic());
 if (Name[0]==0)
   {
    strcpy(NameOri,"(");
    strcat(NameOri,NameOfFile);
    strcat(NameOri,")Top");
    Name=strchr(NameOri,')')+1;
   }
 pos = index->position(index->WhatIndex(Name));
 if (pos > 0 )
     {
      fSeek(pos);
      TInfTopic *topic = new TInfTopic();
      topic->Read(*this);
      if (topic->Status)
        {
         delete topic;
         return(invalidTopic());
        }
      return topic;
     }
 else return(invalidTopic());
}

TInfTopic *TInfFile::invalidTopic()
{
    TInfTopic *topic;
    char *invalidText = _("\n Sorry I can't find this link (press ALT-F1).\n");

    topic =  new TInfTopic();
    topic->Text = newStr(invalidText);
    topic->lSize = strlen(invalidText);
    topic->iLines = 2;

    return topic;
}

int TInfFile::ConvertIt(long Pos)
{
 int ret=0,i;
 char *s;
 FILE *f;
 char Tempo[256],Ori[256];
 Boolean wasCompressed;

 wasCompressed=IsCompressed;
 if (IsCompressed)
    rewind(stream);
 else
    fClose(stream);
 i=0;
 do
   {
    if (IsCompressed)
      {
       strcpy(Ori,"__infc__");
      }
    else
      {
       if (i==index->indirects)
          ExpandName(Ori,NameOfFile,1);
       else
          ExpandName(Ori,index->IndOffsets[i].Name,1);
       stream=fopen(Ori,"rb");
      }
    ExpandName(Tempo,"__infv__",0);
    f=fopen(Tempo,"wb");
    if (stream==NULL || f==NULL) return ret;
    do
     {
      GetLine();
      for (s=Buffer; *s; s++);
      if (*(s-2)=='\r')
        {
         *(s-2)='\n';
         *(s-1)=0;
        }
      fputs(Buffer,f);
     }
    while (!feof(stream));
    fclose(f);
    fclose(stream);
    remove(Ori);
    rename(Tempo,Ori);
    i++;
   }
 while (i<=index->indirects && !IsCompressed);

 // Test if convertion succesfull
 if (wasCompressed)
   {
    stream=fopen(Ori,"rb");
    IsCompressed=True;
   }
 else
    stream=fOpen(NameOfFile);
 if (stream==NULL) return ret;
 iFile++; // force reopen
 fSeek(Pos);
 return 1;
}


