/* ------------------------------------------------------------------------*/
/*                                                                         */
/*   TKEYS.H                                                               */
/*                                                                         */
/*   Copyright (c) Borland International 1991                              */
/*   All Rights Reserved.                                                  */
/*                                                                         */
/* ------------------------------------------------------------------------*/

#if !defined( __TKEYS_H )
#define __TKEYS_H

#define BIOS_KEYBOARD

#ifdef BIOS_KEYBOARD

const ushort

//  Control keys
//
//  NOTE: these Control key definitions are intended only to provide
//  mnemonic names for the ASCII control codes.  They cannot be used
//  to define menu hotkeys, etc., which require scan codes.

    kbCtrlA     = 0x0001,   kbCtrlB     = 0x0002,   kbCtrlC     = 0x0003,
    kbCtrlD     = 0x0004,   kbCtrlE     = 0x0005,   kbCtrlF     = 0x0006,
    kbCtrlG     = 0x0007,   kbCtrlH     = 0x0008,   kbCtrlI     = 0x0009,
    kbCtrlJ     = 0x000a,   kbCtrlK     = 0x000b,   kbCtrlL     = 0x000c,
    kbCtrlM     = 0x000d,   kbCtrlN     = 0x000e,   kbCtrlO     = 0x000f,
    kbCtrlP     = 0x0010,   kbCtrlQ     = 0x0011,   kbCtrlR     = 0x0012,
    kbCtrlS     = 0x0013,   kbCtrlT     = 0x0014,   kbCtrlU     = 0x0015,
    kbCtrlV     = 0x0016,   kbCtrlW     = 0x0017,   kbCtrlX     = 0x0018,
    kbCtrlY     = 0x0019,   kbCtrlZ     = 0x001a,

// Extended key codes

    kbEsc       = 0x011b,   kbAltSpace  = 0x0200,   kbCtrlIns   = 0x0400,
    kbShiftIns  = 0x0500,   kbCtrlDel   = 0x0600,   kbShiftDel  = 0x0700,
    kbCtrlShiftIns = 0x0410, kbCtrlShiftDel = 0x0610,
    kbBack      = 0x0e08,   kbCtrlBack  = 0x0e7f,   kbShiftTab  = 0x0f00,
    kbTab       = 0x0f09,   kbAltQ      = 0x1000,   kbAltW      = 0x1100,
    kbAltE      = 0x1200,   kbAltR      = 0x1300,   kbAltT      = 0x1400,
    kbAltY      = 0x1500,   kbAltU      = 0x1600,   kbAltI      = 0x1700,
    kbAltO      = 0x1800,   kbAltP      = 0x1900,   kbCtrlEnter = 0x1c0a,
    kbEnter     = 0x1c0d,   kbAltA      = 0x1e00,   kbAltS      = 0x1f00,
    kbAltD      = 0x2000,   kbAltF      = 0x2100,   kbAltG      = 0x2200,
    kbAltH      = 0x2300,   kbAltJ      = 0x2400,   kbAltK      = 0x2500,
    kbAltL      = 0x2600,   kbAltZ      = 0x2c00,   kbAltX      = 0x2d00,
    kbAltC      = 0x2e00,   kbAltV      = 0x2f00,   kbAltB      = 0x3000,
    kbAltN      = 0x3100,   kbAltM      = 0x3200,   kbF1        = 0x3b00,
    kbF2        = 0x3c00,   kbF3        = 0x3d00,   kbF4        = 0x3e00,
    kbF5        = 0x3f00,   kbF6        = 0x4000,   kbF7        = 0x4100,
    kbF8        = 0x4200,   kbF9        = 0x4300,   kbF10       = 0x4400,
    kbHome      = 0x4700,   kbUp        = 0x4800,   kbPgUp      = 0x4900,
    kbGrayMinus = 0x4a2d,   kbLeft      = 0x4b00,   kbRight     = 0x4d00,
    kbGrayPlus  = 0x4e2b,   kbEnd       = 0x4f00,   kbDown      = 0x5000,
    kbPgDn      = 0x5100,   kbIns       = 0x5200,   kbDel       = 0x5300,
    kbShiftF1   = 0x5400,   kbShiftF2   = 0x5500,   kbShiftF3   = 0x5600,
    kbShiftF4   = 0x5700,   kbShiftF5   = 0x5800,   kbShiftF6   = 0x5900,
    kbShiftF7   = 0x5a00,   kbShiftF8   = 0x5b00,   kbShiftF9   = 0x5c00,
    kbShiftF10  = 0x5d00,   kbCtrlF1    = 0x5e00,   kbCtrlF2    = 0x5f00,
    kbCtrlF3    = 0x6000,   kbCtrlF4    = 0x6100,   kbCtrlF5    = 0x6200,
    kbCtrlF6    = 0x6300,   kbCtrlF7    = 0x6400,   kbCtrlF8    = 0x6500,
    kbCtrlF9    = 0x6600,   kbCtrlF10   = 0x6700,   kbAltF1     = 0x6800,
    kbAltF2     = 0x6900,   kbAltF3     = 0x6a00,   kbAltF4     = 0x6b00,
    kbAltF5     = 0x6c00,   kbAltF6     = 0x6d00,   kbAltF7     = 0x6e00,
    kbAltF8     = 0x6f00,   kbAltF9     = 0x7000,   kbAltF10    = 0x7100,
    kbCtrlPrtSc = 0x7200,   kbCtrlLeft  = 0x7300,   kbCtrlRight = 0x7400,
    kbCtrlEnd   = 0x7500,   kbCtrlPgDn  = 0x7600,   kbCtrlHome  = 0x7700,
    kbAlt1      = 0x7800,   kbAlt2      = 0x7900,   kbAlt3      = 0x7a00,
    kbAlt4      = 0x7b00,   kbAlt5      = 0x7c00,   kbAlt6      = 0x7d00,
    kbAlt7      = 0x7e00,   kbAlt8      = 0x7f00,   kbAlt9      = 0x8000,
    kbAlt0      = 0x8100,   kbAltMinus  = 0x8200,   kbAltEqual  = 0x8300,
    kbCtrlPgUp  = 0x8400,   kbNoKey     = 0x0000,

//  Keyboard state and shift masks

    kbRightShift  = 0x0001,
    kbLeftShift   = 0x0002,
    kbCtrlShift   = 0x0004,
    kbAltShift    = 0x0008,
    kbScrollState = 0x0010,
    kbNumState    = 0x0020,
    kbCapsState   = 0x0040,
    kbInsState    = 0x0080;

    const kbAltBack=0x0e00;
    
#else
const unsigned

    kbCtrlA     = 0x1E01,   kbCtrlB     = 0x3002,   kbCtrlC     = 0x2E03,
    kbCtrlD     = 0x2004,   kbCtrlE     = 0x1205,   kbCtrlF     = 0x2106,
    kbCtrlG     = 0x2207,   kbCtrlH     = 0x2308,   kbCtrlI     = 0x1709,
    kbCtrlJ     = 0x240a,   kbCtrlK     = 0x250b,   kbCtrlL     = 0x260c,
    kbCtrlM     = 0x320d,   kbCtrlN     = 0x310e,   kbCtrlO     = 0x180f,
    kbCtrlP     = 0x1910,   kbCtrlQ     = 0x1011,   kbCtrlR     = 0x1312,
    kbCtrlS     = 0x1F13,   kbCtrlT     = 0x1414,   kbCtrlU     = 0x1615,
    kbCtrlV     = 0x2F16,   kbCtrlW     = 0x1117,   kbCtrlX     = 0x2D18,
    kbCtrlY     = 0x1519,   kbCtrlZ     = 0x2C1a,

    kbBack= 0x0e08, kbCtrlBack= 0x0e7f, kbShiftBack= 0x0e7e,kbAltBack= 0x0e00,
    kbBackSpace= 0x0e08, kbCtrlBackSpace= 0x0e7f, kbShiftBackSpace= 0x0e7e,kbAltBackSpace= 0x0e00,
    kbTab = 0x0f09, kbCtrlTab = 0x0f7f, kbShiftTab = 0x0f7e,kbAltTab = 0x0f00,
    kbHome      = 0x4700, kbCtrlHome = 0x4702, kbShiftHome = 0x4701, kbShiftCtrlHome = 0x4703,
    kbUp        = 0x4800, kbCtrlUp   = 0x4802, kbShiftUp   = 0x4801,
    kbPgUp      = 0x4900, kbCtrlPgUp = 0x4902, kbShiftPgUp = 0x4901, kbShiftCtrlPgUp = 0x4903,
    kbLeft      = 0x4b00, kbCtrlLeft = 0x4b02, kbShiftLeft = 0x4b01,
    kbRight     = 0x4d00, kbCtrlRight= 0x4d02, kbShiftRight= 0x4d01,
    kbEnd       = 0x4f00, kbCtrlEnd  = 0x4f02, kbShiftEnd  = 0x4f01, kbShiftCtrlEnd  = 0x4f03,
    kbDown      = 0x5000, kbCtrlDown = 0x5002, kbShiftDown = 0x5001,
    kbPgDn      = 0x5100, kbCtrlPgDn = 0x5102, kbShiftPgDn = 0x5101, kbShiftCtrlPgDn = 0x5103,
    kbIns = 0x5200, kbShiftIns = 0x5201, kbCtrlIns = 0x5202, kbAltIns = 0x5204,
    kbDel = 0x5300, kbShiftDel = 0x5301, kbCtrlDel = 0x5302, kbAltDel = 0x5304,
    kbEsc       = 0x011b,

    kbCtrlShiftIns   = 0x5203,
    kbCtrlOpenBrace  = 0x1A02,
    kbCtrlCloseBrace = 0x1B02,
    kbCtrlShiftTab   = 0x0f7f,
    kbShiftSpace     = 0x3901,

    /* Alt+Letters */
    kbAltQ      = 0x1000,   kbAltW      = 0x1100,
    kbAltE      = 0x1200,   kbAltR      = 0x1300,   kbAltT      = 0x1400,
    kbAltY      = 0x1500,   kbAltU      = 0x1600,   kbAltI      = 0x1700,
    kbAltO      = 0x1800,   kbAltP      = 0x1900,
    kbAltA      = 0x1e00,   kbAltS      = 0x1f00,
    kbAltD      = 0x2000,   kbAltF      = 0x2100,   kbAltG      = 0x2200,
    kbAltH      = 0x2300,   kbAltJ      = 0x2400,   kbAltK      = 0x2500,
    kbAltL      = 0x2600,   kbAltZ      = 0x2c00,   kbAltX      = 0x2d00,
    kbAltC      = 0x2e00,   kbAltV      = 0x2f00,   kbAltB      = 0x3000,
    kbAltN      = 0x3100,   kbAltM      = 0x3200,

    kbEnter     = 0x1c0d,   kbCtrlEnter = 0x1c0a,   kbShiftEnter = 0x1c7e,
    kbAltEnter  = 0x1c00,

    /* Function keys */
    kbF1   = 0x3b03,   kbF2   = 0x3c03,   kbF3   = 0x3d03,
    kbF4   = 0x3e03,   kbF5   = 0x3f03,   kbF6   = 0x4003,
    kbF7   = 0x4103,   kbF8   = 0x4203,   kbF9   = 0x4303,
    kbF10  = 0x4403,   kbF11  = 0x5703,   kbF12  = 0x5803,

    /* Shift Function keys */
    kbShiftF1   = 0x3b01,   kbShiftF2   = 0x3c01,   kbShiftF3   = 0x3d01,
    kbShiftF4   = 0x3e01,   kbShiftF5   = 0x3f01,   kbShiftF6   = 0x4001,
    kbShiftF7   = 0x4101,   kbShiftF8   = 0x4201,   kbShiftF9   = 0x4301,
    kbShiftF10  = 0x4401,   kbShiftF11  = 0x5701,   kbShiftF12  = 0x5801,

    /* Ctrl Function keys */
    kbCtrlF1   = 0x3b02,   kbCtrlF2   = 0x3c02,   kbCtrlF3   = 0x3d02,
    kbCtrlF4   = 0x3e02,   kbCtrlF5   = 0x3f02,   kbCtrlF6   = 0x4002,
    kbCtrlF7   = 0x4102,   kbCtrlF8   = 0x4202,   kbCtrlF9   = 0x4302,
    kbCtrlF10  = 0x4402,   kbCtrlF11  = 0x5702,   kbCtrlF12  = 0x5802,

    /* Alt Function keys */
    kbAltF1   = 0x3b00,   kbAltF2   = 0x3c00,   kbAltF3   = 0x3d00,
    kbAltF4   = 0x3e00,   kbAltF5   = 0x3f00,   kbAltF6   = 0x4000,
    kbAltF7   = 0x4100,   kbAltF8   = 0x4200,   kbAltF9   = 0x4300,
    kbAltF10  = 0x4400,   kbAltF11  = 0x5700,   kbAltF12  = 0x5800,

    kbGrayMinus = 0x4a2d,   kbGrayPlus  = 0x4e2b, kbCtrlPrtSc = 0x3700,
    kbAltMinus  = 0x0C00,   kbAltEqual  = 0x0D00,

    /* Numbers+Alt */
    kbAlt1      = 0x0200,   kbAlt2      = 0x0300,   kbAlt3      = 0x0400,
    kbAlt4      = 0x0500,   kbAlt5      = 0x0600,   kbAlt6      = 0x0700,
    kbAlt7      = 0x0800,   kbAlt8      = 0x0900,   kbAlt9      = 0x0A00,
    kbAlt0      = 0x0B00,

    /* Numbers+Ctrl */
    kbCtrl1      = 0x0202,   kbCtrl2      = 0x0302,   kbCtrl3      = 0x0402,
    kbCtrl4      = 0x0502,   kbCtrl5      = 0x0602,   kbCtrl6      = 0x0702,
    kbCtrl7      = 0x0802,   kbCtrl8      = 0x0902,   kbCtrl9      = 0x0A02,
    kbCtrl0      = 0x0B02,


    kbNoKey     = 0x0000,


    kbRightShift  = 0x0001,
    kbLeftShift   = 0x0002,
    kbCtrlShift   = 0x0004,
    kbAltShift    = 0x0008,
    kbScrollState = 0x0010,
    kbNumState    = 0x0020,
    kbCapsState   = 0x0040,
    kbInsState    = 0x0080;
#endif

#endif	// __TKEYS_H
